<?php
$GLOBALS["__65da1b1ec2d6653e8a0ab78" . "48e536215"] = (@$GLOBALS["__65da1b1ec2d6653e8a0ab7848e53" . "6215"] ?: array()) + array("_1d5727e95902d" . "6ca0a94581ac86" . "acf26" => base64_decode("QXR0ZW1wdCB0byBsb2FkIGF0dGVuZGVlcyBsaXN0IHdpdGggbm8gbGlzdF" . "9pZA=="), "_f5e940c614f55e70f21" . "0df8306ffbd17" => base64_decode("YXJyYXlfZmlsbF9rZX" . "lz"), "_31767d7ad58e706d" . "bf47b7a51a0fe6c4" => base64_decode("Y29" . "1bn" . "Q="), "_cce0d019" . "091a193c2" . "ea098ab90" . "2d8821" => base64_decode("QXR0ZW1wdCB0byBzYXZlIGF0dGVuZGVlcyB" . "3aXRoIG5vIGxpc3RfaWQh"), "_4d2b763f" . "00ba1e800" . "1879ba79a" . "849269" => base64_decode("YXJyYXlf" . "aW50ZXJz" . "ZWN0X2tl" . "eQ=="), "_39b6f979f725d2d066951011e1554c" . "14" => base64_decode("YXJyY" . "XlfZG" . "lmZl9" . "rZXk="), "_a839150" . "4b805b5d" . "572e9b1a" . "5c5d0169" . "e" => base64_decode("Tm8gbG" . "lzdCBp" . "ZA=="), "_c06c961f393742ecfd52b7226" . "3ac9470" => base64_decode("aW5" . "0dm" . "Fs"), "_c336a736f98472e69eb0" . "0017dda5a17e" => base64_decode("dHJpZ2dlcl9lc" . "nJvcg=="));
abstract class CalendarEventParticipants extends ErrorHandler
{
    protected $is_list_loaded;
    protected $list_id = false;
    protected $users = array();
    protected $deleted_users = array();
    protected $new_users = array();
    protected $old_users = array();
    
    
    
    
    protected $event;
    public function __construct(CalendarObject $event)
    {
        $this->event = $event;
        $this->is_list_loaded = false;
    }
    
    
    
    
    
    
    public function SetUsers($_c9cc2169cfc80b4728d6b39dfdcba6bb)
    {
        
        
        $_c9cc2169cfc80b4728d6b39dfdcba6bb = $GLOBALS["__65da1b1ec2d665" . "3e8a0ab7848e5362" . "15"]["_f5e940c" . "614f55e7" . "0f210df8" . "306ffbd1" . "7"]($_c9cc2169cfc80b4728d6b39dfdcba6bb, 1);
        
        
        $this->deleted_users = $GLOBALS["__65da1b1ec2d6653e8a0ab7" . "848e536215"]["_39b6f979f725d2d066951011e15" . "54c14"]($this->users, $_c9cc2169cfc80b4728d6b39dfdcba6bb);
        $this->new_users = $GLOBALS["__65da1b1ec2d6653e8a0" . "ab7848e536215"]["_39b6f979f725d2d0669510" . "11e1554c14"]($_c9cc2169cfc80b4728d6b39dfdcba6bb, $this->users);
        $this->old_users = $GLOBALS["__65da1b1ec2d665" . "3e8a0ab7848e5362" . "15"]["_4d2b763f00ba1e8001879ba" . "79a849269"]($this->users, $_c9cc2169cfc80b4728d6b39dfdcba6bb);
        $this->is_list_loaded = true;
    }
    public function Load()
    {
        if (!$this->list_id) {
            throw new Exception($GLOBALS["__65da1b1ec2d" . "6653e8a0ab784" . "8e536215"]["_1d5727e959" . "02d6ca0a945" . "81ac86acf26"]);
        }
        $this->deleted_users = array();
        $this->new_users = array();
        $this->old_users = array();
        $this->is_list_loaded = true;
    }
    public function SetListId($_0ea4e32b57963ac0cb3057e03e9aef64)
    {
        $this->list_id = $GLOBALS["__65da1b1ec2d6653e8a0ab7848e53" . "6215"]["_c06c961f393742ecfd52b72263a" . "c9470"]($_0ea4e32b57963ac0cb3057e03e9aef64);
        if ($_0ea4e32b57963ac0cb3057e03e9aef64 === null) {
            $this->is_list_loaded = true;
        }
    }
    
    
    
    
    
    
    public function isAttendeesChanged()
    {
        return $GLOBALS["__65da1b1ec2d6653e8" . "a0ab7848e536215"]["_31767d7a" . "d58e706db" . "f47b7a51a" . "0fe6c4"]($this->new_users) > 0 || $GLOBALS["__65da1b1ec2d6653e8a0ab" . "7848e536215"]["_31767d7a" . "d58e706db" . "f47b7a51a" . "0fe6c4"]($this->deleted_users) > 0;
    }
    public function Save()
    {
        if (!$this->list_id) {
            $GLOBALS["__65da1b1ec2d6653e8a0ab784" . "8e536215"]["_c336a736f98472e" . "69eb00017dda5a17" . "e"]($GLOBALS["__65da1b1ec2d6653e8a" . "0ab7848e536215"]["_a8391504b805b5d" . "572e9b1a5c5d0169" . "e"]);
            throw new Exception($GLOBALS["__65da1b1" . "ec2d6653e" . "8a0ab7848" . "e536215"]["_cce0d019091a193c2ea098ab902d88" . "21"]);
        }
        $this->SaveNewUsers();
        $this->DeleteUnattendedUsers();
        foreach ($this->new_users as $user_id => $_c96f552040dea8086bf8bdd70059542f) {
            $this->users[$user_id] = $_c96f552040dea8086bf8bdd70059542f;
        }
        
        
        $this->users = $GLOBALS["__65da1b1ec2d6653e8a0ab78" . "48e536215"]["_39b6f979f725d2d" . "066951011e1554c1" . "4"]($this->users, $this->deleted_users);
        
        
    }
    public function GetNewUsers()
    {
        if (!$this->is_list_loaded) {
            $this->Load();
        }
        return $this->new_users;
    }
    public function GetAllUsers()
    {
        if (!$this->is_list_loaded) {
            $this->Load();
        }
        return (array) $this->users;
    }
    public function GetOldUsers()
    {
        if (!$this->is_list_loaded) {
            $this->Load();
        }
        return (array) $this->old_users;
    }
    public function GetDeletedUsers()
    {
        if (!$this->is_list_loaded) {
            $this->Load();
        }
        return (array) $this->deleted_users;
    }
    protected abstract function SaveNewUsers();
    protected abstract function DeleteUnattendedUsers();
}